//------------------------------------------------------------------ 
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_separate_window 
#property indicator_buffers 8
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  50
#property indicator_levelcolor DarkGray

//
//
//
//
//

enum enRsiMethod
{
   rsi_rsi,  // rsi
   rsi_wil,  // Wilders' rsi
   rsi_rsx,  // rsx
   rsi_cut   // Cuttlers rsi
};
enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

extern string          RsiTimeFrames   = "0;0;0;0;0;0;0";
extern string          RsiPeriods      = "5;10;15;20;25;30;40";
extern enRsiMethod     RsiMethod       = rsi_rsi;
extern enPrices        RsiPrice        = pr_close;
extern color           StartColor      = LimeGreen;
extern color           EndColor        = PaleVioletRed;
extern bool            Interpolate     = true;
extern bool            alertsOn        = false;
extern bool            alertsOnCurrent = true;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsEmail     = false;
extern bool            alertsNotify    = false;
extern int             linesWidth      = 0;
extern ENUM_LINE_STYLE linesStyle      = STYLE_SOLID;

//
//
//
//
//

double rsi1[];
double rsi2[];
double rsi3[];
double rsi4[];
double rsi5[];
double rsi6[];
double rsi7[];
double rsi8[];
double periods[];
double timeFrames[];

//
//
//
//
//

string indicatorFileName;
int    total;
bool   calculateValue;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void addPeriod(int period)
{
   if (period>0)
   {
      total = ArraySize(periods)+1;
              ArrayResize(periods,total);
                          periods[total-1] = period;
   }
}

//
//
//
//
//

int init() 
{
   SetIndexBuffer(0,rsi1);
   SetIndexBuffer(1,rsi2);
   SetIndexBuffer(2,rsi3);
   SetIndexBuffer(3,rsi4);
   SetIndexBuffer(4,rsi5);
   SetIndexBuffer(5,rsi6);
   SetIndexBuffer(6,rsi7);
   SetIndexBuffer(7,rsi8);
   
      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      returnBars        = RsiTimeFrames=="returnBars"; if (returnBars) return(0);
      calculateValue    = RsiTimeFrames=="calculateValue";
         if (calculateValue)
         {
            ArrayResize(periods,1); periods[0] = StrToInteger(RsiPeriods); return(0);
         }            

      //
      //
      //
      //
      //
            
      RsiPeriods = StringTrimLeft(StringTrimRight(RsiPeriods));
      if (StringSubstr(RsiPeriods,StringLen(RsiPeriods),1) != ";")
                       RsiPeriods = StringConcatenate(RsiPeriods,";");

         //
         //
         //
         //
         //                                   
            
         int s = 0;
         int i = StringFind(RsiPeriods,";",s);
            while (i > 0)
            {
               addPeriod(StrToInteger(StringSubstr(RsiPeriods,s,i-s)));
               s = i + 1; i = StringFind(RsiPeriods,";",s);
            }
            total = MathMin(total,8);
 
      //
      //
      //
      //
      //
         
      RsiTimeFrames = StringTrimLeft(StringTrimRight(RsiTimeFrames));
      if (StringSubstr(RsiTimeFrames,StringLen(RsiTimeFrames),1) != ";")
                       RsiTimeFrames = StringConcatenate(RsiTimeFrames,";");

         //
         //
         //
         //
         //                                   
         
         ArrayResize(timeFrames,total); ArrayInitialize(timeFrames,0);   
         s = 0;
         i = StringFind(RsiTimeFrames,";",s);
         int current = 0;
            while (i > 0 && current<total)
            {
               int time = stringToTimeFrame(StringSubstr(RsiTimeFrames,s,i-s));
                   timeFrames[current] = time;
                   current += 1; s = i + 1; i = StringFind(RsiTimeFrames,";",s);
                   
            }

      //
      //
      //
      //
      //
            
      string name = "";
         for (i=0; i<total; i++)
         {  
            if (name!="")
                name = name+",";
                name = name+DoubleToStr(periods[i],0);
         }         
      IndicatorShortName("Multi "+getRsiName(RsiMethod)+" ("+name+")"); 
   return(0); 
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double state[][8];
int start() 
{ 
   static bool initialized = false;
   int j,k,n,r,counted_bars=IndicatorCounted();
      if (counted_bars < 0) return(-1);
      if (counted_bars > 0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { rsi1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue) { for (int i=limit; i>=0; i--) rsi1[i] = iRsi(getPrice(RsiPrice,Open,Close,High,Low,i),periods[0],i,0,RsiMethod); return(0); }    
   if (!initialized)
   {
      initialized=true;
         for (k = 0; k<total; k++) SetIndexStyle(k,EMPTY,linesStyle,linesWidth,gradientColor(k,total,StartColor,EndColor));
   }            

   //
   //
   //
   //
   //
   
   if (ArrayRange(state,0)!=Bars) ArrayResize(state,Bars);
   for (k=0; k<total; k++) if (timeFrames[k] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[k],indicatorFileName,"returnBars",0,0)*timeFrames[k]/Period()));
   for (k=0; k<total; k++)
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = getPrice(RsiPrice,Open,Close,High,Low,i);
      if (timeFrames[k] == _Period) 
               double rsi = iRsi(price,periods[k],i,k,RsiMethod);
      else 
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
                rsi = iCustom(NULL,timeFrames[k],indicatorFileName,"calculateValue",DoubleToStr(periods[k],0),RsiMethod,RsiPrice,0,y);
      }
            
      //
      //
      //
      //
      //
                               
      switch (k)
      {
         case 0: rsi1[i] = rsi; state[r][0] = state[r-1][0]; if (rsi>50) state[r][0] = 1; if (rsi<50) state[r][0] = -1; break;
         case 1: rsi2[i] = rsi; state[r][1] = state[r-1][1]; if (rsi>50) state[r][1] = 1; if (rsi<50) state[r][1] = -1; break;
         case 2: rsi3[i] = rsi; state[r][2] = state[r-1][2]; if (rsi>50) state[r][2] = 1; if (rsi<50) state[r][2] = -1; break;
         case 3: rsi4[i] = rsi; state[r][3] = state[r-1][3]; if (rsi>50) state[r][3] = 1; if (rsi<50) state[r][3] = -1; break;
         case 4: rsi5[i] = rsi; state[r][4] = state[r-1][4]; if (rsi>50) state[r][4] = 1; if (rsi<50) state[r][4] = -1; break;
         case 5: rsi6[i] = rsi; state[r][5] = state[r-1][5]; if (rsi>50) state[r][5] = 1; if (rsi<50) state[r][5] = -1; break;
         case 6: rsi7[i] = rsi; state[r][6] = state[r-1][6]; if (rsi>50) state[r][6] = 1; if (rsi<50) state[r][6] = -1; break;
         case 7: rsi8[i] = rsi; state[r][7] = state[r-1][7]; if (rsi>50) state[r][7] = 1; if (rsi<50) state[r][7] = -1; break;
      }
            
      //
      //
      //
      //
      //
            
      if (!Interpolate || timeFrames[k] <= Period() || y==iBarShift(NULL,timeFrames[k],Time[i-1])) continue;

      //
      //
      //
      //
      //

      datetime time = iTime(NULL,timeFrames[k],y);
          for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
          for(j = 1; j < n; j++)
            switch (k)
            {
                case 0 : rsi1[i+j] = rsi1[i] + (rsi1[i+n] - rsi1[i])*j/n; break;
                case 1 : rsi2[i+j] = rsi2[i] + (rsi2[i+n] - rsi2[i])*j/n; break;
                case 2 : rsi3[i+j] = rsi3[i] + (rsi3[i+n] - rsi3[i])*j/n; break;
                case 3 : rsi4[i+j] = rsi4[i] + (rsi4[i+n] - rsi4[i])*j/n; break;
                case 4 : rsi5[i+j] = rsi5[i] + (rsi5[i+n] - rsi5[i])*j/n; break;
                case 5 : rsi6[i+j] = rsi6[i] + (rsi6[i+n] - rsi6[i])*j/n; break;
                case 6 : rsi7[i+j] = rsi7[i] + (rsi7[i+n] - rsi7[i])*j/n; break;
                case 7 : rsi8[i+j] = rsi8[i] + (rsi8[i+n] - rsi8[i])*j/n; break;
            }
   }
   manageAlerts();
   return(0); 
} 

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string   pAlerts[8];
datetime pTimes[8];
void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      for (int k=0; k<total; k++)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1; whichBar = Bars-iBarShift(NULL,0,iTime(NULL,timeFrames[k],whichBar))-1;
         if (state[whichBar][k] != state[whichBar-1][k])
         {
            if (state[whichBar][k] ==  1) doAlert(k,"up"  ,timeFrames[k],periods[k]);
            if (state[whichBar][k] == -1) doAlert(k,"down",timeFrames[k],periods[k]);
         }
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat, int timeFrame, int period)
{
   string message;
   
   if (pAlerts[forBar] != doWhat || pTimes[forBar] != iTime(NULL,timeFrame,0)) {
       pAlerts[forBar]  = doWhat;
       pTimes[forBar]   = iTime(NULL,timeFrame,0);

       //
       //
       //
       //
       //

       message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+period+" "+getRsiName(RsiMethod)+" crossed 50 line "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),getRsiName(RsiMethod)),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string rsiMethodNames[] = {"rsi","Wilders rsi","rsx","Cuttler RSI"};
string getRsiName(int method)
{
   int max = ArraySize(rsiMethodNames)-1;
      method=MathMax(MathMin(method,max),0); return(rsiMethodNames[method]);
}

//
//
//
//
//

double workRsi[][104];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int i, int instanceNo=0, int rsiMode=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*13; 
      int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[r][z+_price] = price;
   switch (rsiMode)
   {
      case 0:
         double alpha = 1.0/period; 
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
         
      //
      //
      //
      //
      //
      
      case 1 :
         workRsi[r][z+1] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])+(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,0);
         workRsi[r][z+2] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])-(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,1);
         if((workRsi[r][z+1] + workRsi[r][z+2]) != 0) 
               return(100.0 * workRsi[r][z+1]/(workRsi[r][z+1] + workRsi[r][z+2]));
         else  return(50);

      //
      //
      //
      //
      //

      case 2 :     
         double Kg = (3.0)/(2.0+period), Hg = 1.0-Kg;
         if (r<period) { for (k=1; k<13; k++) workRsi[r][k+z] = 0; return(50); }  

         //
         //
         //
         //
         //
      
         double mom = workRsi[r][_price+z]-workRsi[r-1][_price+z];
         double moa = MathAbs(mom);
         for (k=0; k<3; k++)
         {
            int kk = k*2;
            workRsi[r][z+kk+1] = Kg*mom                + Hg*workRsi[r-1][z+kk+1];
            workRsi[r][z+kk+2] = Kg*workRsi[r][z+kk+1] + Hg*workRsi[r-1][z+kk+2]; mom = 1.5*workRsi[r][z+kk+1] - 0.5 * workRsi[r][z+kk+2];
            workRsi[r][z+kk+7] = Kg*moa                + Hg*workRsi[r-1][z+kk+7];
            workRsi[r][z+kk+8] = Kg*workRsi[r][z+kk+7] + Hg*workRsi[r-1][z+kk+8]; moa = 1.5*workRsi[r][z+kk+7] - 0.5 * workRsi[r][z+kk+8];
         }
         if (moa != 0)
              return(MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)); 
         else return(50);
            
      //
      //
      //
      //
      //
      
      case 3 :
         double sump = 0;
         double sumn = 0;
         for (k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
   } 
   return(0);
}

//
//
//
//
//
//

double workSmma[][2];
double iSmma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= Bars) ArrayResize(workSmma,Bars);

   //
   //
   //
   //
   //

   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," WaddahAttarExplosion ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " WaddahAttarExplosion "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}